#!/usr/bin/perl

use warnings;
use strict;

use IO::Socket::IP;
use IO::Handle;
use IO::Select;

use Getopt::Std;

my %opts;
getopt('spn', \%opts);

use constant BUFSIZE => 1024;

my $host = $opts{s};
my $port = $opts{p};

my $socket = IO::Socket::IP->new(
    PeerHost => $host,
    PeerPort => $port,
    Type     => SOCK_STREAM,
) or die "Cannot construct socket - $@";

my $readers = IO::Select->new();

$readers->add(\*STDIN);
$readers->add($socket);

my $buffer;
while (1) {
    my @ready = $readers->can_read();
    for my $handle (@ready) {
        if ($handle eq \*STDIN) {
            if (sysread(STDIN,$buffer,BUFSIZE)>0) {
                syswrite($socket, "$opts{n} $buffer");
            }
        }
        elsif ($handle eq $socket) {
            if (sysread($socket,$buffer,BUFSIZE)>0) {
                syswrite(STDOUT,$buffer);
            }
        }
    }
}
