#!/usr/bin/perl

use warnings;
use strict;

use IO::Socket::IP;
use IO::Handle;
use IO::Select;

use Getopt::Std;

my %opts;
getopt('p', \%opts);

use constant BUFSIZE => 1024;

my $port    = $opts{p};


my $listen_socket = IO::Socket::INET->new(
    Listen    => 10, 
    LocalPort => $port,
    LocalHost => '127.0.0.1',
    Reuse     => 1,
);

my $sel = IO::Select->new();
$sel->add($listen_socket);

my %SESSION;
my %MSGS;

while(1) {
    my @ready = $sel->can_read();
    for my $handle (@ready) {
        if ($handle eq $listen_socket) {
            my $connect = $listen_socket->accept();
            my $buffer;
            syswrite($connect, "Welcome!\n");
            $SESSION{$connect} = $connect;
            $sel->add($connect);
        }
        elsif ($SESSION{$handle}) {
            my $buffer;
            my $bytes = sysread($handle, $buffer, BUFSIZE);
            if ($bytes > 0) {
                foreach my $session (keys %SESSION) {
                    next if $handle eq $session;
                    syswrite($SESSION{$session}, $buffer);
                }
            }
            else {
                $sel->remove($handle);
                close($handle);
                delete $SESSION{$handle};
            }
        }
    }
}
